---
- name: Request Let's Encrypt certificates for {{ app.domain }} if enabled
  command: 
    cmd: "certbot --nginx -d {{ app.domain }} --non-interactive --agree-tos -m {{ admin_email }} --redirect"
  when: app.enabled
  notify: reload nginx
  become: true

- name: Add ssl_trusted_certificate to vhost config for {{ app.domain }}
  lineinfile:
    path: /etc/nginx/sites-available/{{ app.domain }}
    line: '    ssl_trusted_certificate /etc/letsencrypt/live/{{ app.domain }}/chain.pem;'
    insertafter: 'ssl_certificate_key /etc/letsencrypt/live/{{ app.domain }}/privkey.pem;'
  when: app.enabled
  notify: reload nginx
  become: true

# Determine if any app is enabled
- name: Check if any app is enabled
  set_fact:
    any_app_enabled: true
  when: app.enabled
  run_once: true
  become: false

# Set up cron job if at least one app is enabled
- name: Setup automatic renewal cron job for Certbot
  cron:
    name: "Certbot renew certificates"
    minute: "25"
    hour: "2"
    job: "/usr/bin/certbot renew --quiet --post-hook 'systemctl reload nginx' >> /var/log/certbot-renew.log 2>&1"
    state: present
  when: any_app_enabled|default(false)
  become: true

# Remove cron job if no app is enabled
- name: Remove Certbot cron job if no apps are enabled
  cron:
    name: "Certbot renew certificates"
    state: absent
  when: not any_app_enabled|default(false)
  become: true
